/*
 * File:		demo_bootloader.c
 * Purpose:		Main process
 *
 */

#include "common.h"
#include "flag.h"
#include "freedom_gpio.h"

#ifdef CMSIS
#include "start.h"
#endif

uint8_t m_bFlag = 0;

void Delay( uint32_t uiCount );

void Delay( uint32_t uiCount )
{
	uint32_t i,j;
	
	for( i=0;i<uiCount;i++ )
	{
		for(j=0;j<100;j++);
	}
}
/********************************************************************/
int main (void)
{
  char ch;
  gpio_init();     
  printf("\nRunning the demo_bootloader project.\n");
  m_bFlag = 1;
	while(1)
	{
			Delay(20000);
			LED1_TOGGLE;
			Delay(20000);
			LED2_TOGGLE;
			Delay(20000);
			LED3_TOGGLE;
		
			if( m_bFlag )
			{
				printf("\n");
			}
		
			if( UART0_S1 & UART0_S1_RDRF_MASK )
			{
					ch = UART0_D;
					if( ch == 'b' )
					{
						Write_WorkMode(WORK_MODE_BOOT_LOADER);
                        SCB_AIRCR = SCB_AIRCR_SYSRESETREQ_MASK|0x05fa0000;
                        while(1);
					}
			}
	} 
}
/********************************************************************/
